define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for Home generated by Appery.io
         * @module Home
         */
        APP.controller('Home', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.username = Apperyio.EntityAPI('String');
            $scope.password = Apperyio.EntityAPI('String');
            $scope.user = Apperyio.EntityAPI('User');
            $scope.opeator = Apperyio.EntityAPI('OperatorList');
            $scope.company = Apperyio.EntityAPI('CompanyList');
            $scope.allUsers = Apperyio.EntityAPI('OperatorList');
            $scope.allNames = Apperyio.EntityAPI('NamesList');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                // Validar si el usuario tiene sesión activa
                //localStorage.clear(); 
                //sessionStorage.clear(); 
                $('#inputBuscar').focus();
                $("#inputBuscar").keypress(function(event) {
                    //console.log( "Handler for .keypress() called.: " + event.which);
                    if (event.which == 13) {
                        $scope.login();
                    }
                });
                var $routeParams = Apperyio.get("$routeParams");
                //La página se invoca con parámetros get
                if ($routeParams) {
                    $scope.usernameExt = $routeParams.username;
                    $scope.passwordExt = $routeParams.password;
                    $scope.enterExt = $routeParams.enter;
                }
                if (localStorage.getItem("userData")) {
                    $scope.user = JSON.parse(localStorage.getItem("userData"));
                    //Recuperar datos del usuario
                    $scope.showLoading();
                    $scope.getMe()
                }
                //
            };
            /**
             * @function login
             */
            $scope.login = function() {
                $scope.showLoading();
                var requestData = {};
                requestData = (function mapping9516($scope) {
                    var requestData = {};
                    requestData.data = {};
                    var username_scope = $scope.username;
                    var password_scope = $scope.password;
                    _.set(requestData.data, 'username', username_scope);
                    _.set(requestData.data, 'password', password_scope);
                    return requestData;
                    /*|button_mapping|onbeforesend|9D8809AB-1ACB-06E7-6894-EBF66B37F7A7||9516|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_login_service")(requestData).then( /*|service_bookmark|bookmark|9D8809AB-1ACB-06E7-6894-EBF66B37F7A7||6257|*/
                    function(success) { // success callback
                        (function mapping5654(success, $scope) {
                            var user_scope = $scope.user;
                            _.set(user_scope, 'token', success.data.sessionToken);
                            $scope.user = user_scope;
                            /*|button_mapping|onsuccess|9D8809AB-1ACB-06E7-6894-EBF66B37F7A7||5654|*/
                            $scope.getMe();
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        Apperyio.get('Modals').loadModal("MensajeError").then(
                            function(modal) {
                                modal.scope.current_item = {
                                    // Set input object for send to modal window
                                    // Value: .itemFromModal
                                };
                                modal.scope.modalInstance = modal.open({
                                    // Optional settings:
                                    size: 'sm',
                                    /* 'lg' | 'sm' */
                                    backdrop: true,
                                    /* true | false | 'static' */
                                    keyboard: true,
                                    /* true | false */
                                    backdropClass: '',
                                    /* backdropClass name */
                                    windowClass: '',
                                    /* additional CSS class(es) to be added to a modal window template */
                                    windowTemplateUrl: '' /* a path to a template overriding modal's window template */
                                });
                                modal.scope.modalInstance.result.then(
                                    function(current_item) {
                                        // Custom implementation with modal response with current_item
                                    },
                                    function(error) {
                                        console.log(error);
                                    }
                                );
                            });
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function getMe
             */
            $scope.getMe = function() {
                var requestData = {};
                requestData = (function mapping2016($scope) {
                    var requestData = {};
                    requestData.headers = {};
                    var user_scope = $scope.user;
                    requestData.headers['X-Appery-Session-Token'] = user_scope.token;
                    return requestData;
                    /*|button_mapping|onbeforesend|41499CCA-BD41-81EA-8B6A-B39B0ACC4224||2016|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_me_service")(requestData).then( /*|service_bookmark|bookmark|41499CCA-BD41-81EA-8B6A-B39B0ACC4224||9897|*/
                    function(success) { // success callback
                        (function mapping3611(success, $scope) {
                            var user_scope = $scope.user;
                            _.set(user_scope, 'username', success.data.username);
                            _.set(user_scope, 'email', success.data.email);
                            _.set(user_scope, 'fullName', success.data.fullName);
                            _.set(user_scope, 'codigoOperador', success.data.codigoOperador);
                            _.set(user_scope, '_id', success.data._id);
                            $scope.user = user_scope;
                            /*|button_mapping|onsuccess|41499CCA-BD41-81EA-8B6A-B39B0ACC4224||3611|*/
                            localStorage.setItem("userData", JSON.stringify($scope.user));
                            getOperatorData();
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        //alert("Hubo problemas al obtener información del usuario: " + error.data.code + " " + error.data.description);
                        console.log("Hubo problemas al obtener información del usuario: " + error.data.code + " " + error.data.description);
                        localStorage.clear();
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function getOperatorData
             */
            function getOperatorData() {
                $scope.opeator = [];
                var requestData = {};
                requestData = (function mapping2994($scope) {
                    var requestData = {};
                    requestData.params = {};
                    var user_scope = $scope.user;
                    requestData.params.where = {
                        "idOperador": user_scope.codigoOperador
                    };
                    return requestData;
                    /*|button_mapping|onbeforesend|FFB6DE32-3F15-94E3-2CE0-E75069E84835||2994|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_OPERATORS_query_service")(requestData).then( /*|service_bookmark|bookmark|FFB6DE32-3F15-94E3-2CE0-E75069E84835||7568|*/
                    function(success) { // success callback
                        (function mapping5641(success, $scope) {
                            var opeator_scope = $scope.opeator;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(opeator_scope, '[' + i + '].idCliente', success.data[i].idCliente);
                                _.set(opeator_scope, '[' + i + '].idOperador', success.data[i].idOperador);
                                _.set(opeator_scope, '[' + i + '].estadoOperador', success.data[i].estadoOperador);
                                _.set(opeator_scope, '[' + i + '].profile', success.data[i].profile);
                                _.set(opeator_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(opeator_scope, '[' + i + '].lastSessionHour', success.data[i].lastSessionHour);
                                _.set(opeator_scope, '[' + i + '].lastSessionToken', success.data[i].lastSessionToken);
                            }
                            $scope.opeator = opeator_scope;
                            /*|button_mapping|onsuccess|FFB6DE32-3F15-94E3-2CE0-E75069E84835||5641|*/
                            if ($scope.opeator.length === 0) {
                                $scope.stopLoading();
                                alert("Usuario no tiene empresa asignada. contáctese con el administrador");
                                localStorage.clear();
                            } else {
                                operador = $scope.opeator[0];
                                if (!operador.estadoOperador) {
                                    $scope.stopLoading();
                                    alert("Usuario o cuenta bloqueado para empresa " + operador.idCliente);
                                    localStorage.clear();
                                } else if (operador.profile != "AD" && operador.profile != "AG") {
                                    $scope.stopLoading();
                                    alert("Usuario no tiene permisos para acceder al sitio de empresa " + operador.idCliente);
                                    localStorage.clear();
                                } else if (operador.lastSessionToken && operador.lastSessionToken != $scope.uniqueToken &&
                                    operador.lastSessionHour && operador.lastSessionHour.toString() > $scope.dateJsToDb($scope.addSeconds($scope.secEventBusyDetect * -1))) {
                                    $scope.stopLoading();
                                    alert("Existe una sesión iniciada en otro equipo");
                                    localStorage.clear();
                                } else {
                                    localStorage.setItem("operatorData", JSON.stringify(operador));
                                    getCompanyData(operador.idCliente);
                                }
                                $scope.$parent.$parent.isRoot = operador.profile == "AG";
                            }
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        alert("Hubo problemas al obtener información del usuario: " + error.data.code + " " + error.data.description);
                        localStorage.clear();
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function getCompanyData
             * @param companyId
             */
            function getCompanyData(companyId) {
                $scope.company = [];
                var requestData = {};
                requestData = (function mapping6513($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "idCliente": companyId
                    };
                    return requestData;
                    /*|button_mapping|onbeforesend|7A3ADDB1-07B8-4ECB-610D-20DCB0DCEAB4||6513|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_CLIENT_query_service")(requestData).then( /*|service_bookmark|bookmark|7A3ADDB1-07B8-4ECB-610D-20DCB0DCEAB4||6039|*/
                    function(success) { // success callback
                        (function mapping3472(success, $scope) {
                            var company_scope = $scope.company;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(company_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(company_scope, '[' + i + '].idCliente', success.data[i].idCliente);
                                _.set(company_scope, '[' + i + '].dirCliente', success.data[i].dirCliente);
                                _.set(company_scope, '[' + i + '].nombreCliente', success.data[i].nombreCliente);
                                _.set(company_scope, '[' + i + '].telefonoCliente', success.data[i].telefonoCliente);
                                _.set(company_scope, '[' + i + '].emailCliente', success.data[i].emailCliente);
                                _.set(company_scope, '[' + i + '].clienteLogo', success.data[i].clienteLogo);
                                _.set(company_scope, '[' + i + '].geoPos', success.data[i].geoPos);
                                _.set(company_scope, '[' + i + '].emailNotificaciones', success.data[i].emailNotificaciones);
                                _.set(company_scope, '[' + i + '].config', success.data[i].dataAdd);
                            }
                            $scope.company = company_scope;
                            if ($scope.company.length === 0) {
                                $scope.stopLoading();
                                alert("No existe información para empresa " + companyId + ". Contáctese con el administrador");
                                localStorage.clear();
                            } else {
                                //Almacenamos los datos de la empresa            
                                localStorage.setItem("companyData", JSON.stringify($scope.company[0]));
                                //Cargamos la configuración de los Objetos maestros
                                $scope.loadScopeConfig($scope.company[0].config);
                                //Obtenemos TODOS los usuarios del sistema para la empresa
                                var requestData = {};
                                requestData = (function mapping6136($scope) {
                                    var requestData = {};
                                    requestData.params = {};
                                    requestData.params.where = {
                                        "$and": [{
                                                "idCliente": companyId
                                            },
                                            //{"profile": "OP"},
                                        ]
                                    };
                                    return requestData;
                                    /*|button_mapping|onbeforesend|7449663D-3D1F-92C0-4285-EE793FE910A5||6136|*/
                                })($scope);
                                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                                Apperyio.get("Tech1_OPERATORS_query_service")(requestData).then( /*|service_bookmark|bookmark|7449663D-3D1F-92C0-4285-EE793FE910A5||6838|*/
                                    function(success) { // success callback
                                        (function mapping2444(success, $scope) {
                                            var allUsers_scope = $scope.allUsers;
                                            for (var i = 0, l = success.data.length; i < l; i++) {
                                                _.set(allUsers_scope, '[' + i + '].idCliente', success.data[i].idCliente);
                                                _.set(allUsers_scope, '[' + i + '].idOperador', success.data[i].idOperador);
                                                _.set(allUsers_scope, '[' + i + '].estadoOperador', success.data[i].estadoOperador);
                                                _.set(allUsers_scope, '[' + i + '].profile', success.data[i].profile);
                                            }
                                            $scope.allUsers = allUsers_scope;
                                            /*|button_mapping|onsuccess|7449663D-3D1F-92C0-4285-EE793FE910A5||2444|*/
                                        })(success, $scope);
                                        //Traemos una lista con los nombres
                                        var listaUsuarios = [];
                                        for (var i = 0; i < $scope.allUsers.length; ++i) {
                                            listaUsuarios.push($scope.allUsers[i].idOperador);
                                        }
                                        var requestData = {};
                                        requestData = (function mapping4933($scope) {
                                            var requestData = {};
                                            requestData.params = {};
                                            requestData.params.where = {
                                                "codigoOperador": {
                                                    "$in": listaUsuarios
                                                }
                                            };
                                            return requestData;
                                            /*|button_mapping|onbeforesend|282735BE-37C7-723E-9421-9C5A6E9E01BF||4933|*/
                                        })($scope);
                                        // read more about using rest services: https://links.appery.io/ve-snippet-rest
                                        Apperyio.get("Tech1_user_query_service")(requestData).then( /*|service_bookmark|bookmark|282735BE-37C7-723E-9421-9C5A6E9E01BF||4965|*/
                                            function(success) { // success callback
                                                (function mapping4617(success, $scope) {
                                                    var allNames_scope = $scope.allNames;
                                                    for (var i = 0, l = success.data.length; i < l; i++) {
                                                        _.set(allNames_scope, '[' + i + '].fullName', success.data[i].fullName);
                                                        _.set(allNames_scope, '[' + i + '].codigoOperador', success.data[i].codigoOperador);
                                                        _.set(allNames_scope, '[' + i + '].username', success.data[i].username);
                                                        $scope.allNamesAsoc[success.data[i].codigoOperador] = success.data[i].fullName;
                                                        $scope.allUsernamesAsoc[success.data[i].codigoOperador] = success.data[i].username;
                                                    }
                                                    $scope.allNames = allNames_scope;
                                                    /*|button_mapping|onsuccess|282735BE-37C7-723E-9421-9C5A6E9E01BF||4617|*/
                                                })(success, $scope);
                                                $scope.operators = [];
                                                $scope.administrators = [];
                                                $scope.administratorsG = [];
                                                //armar arreglo de operadores
                                                for (var i = 0; i < $scope.allUsers.length; ++i) {
                                                    if ($scope.allUsers[i].profile == "OP") {
                                                        $scope.operators.push({
                                                            codigo: $scope.allUsers[i].idOperador,
                                                            nombre: $scope.allNamesAsoc[$scope.allUsers[i].idOperador],
                                                            username: $scope.allUsernamesAsoc[$scope.allUsers[i].idOperador]
                                                        });
                                                    } else if ($scope.allUsers[i].profile == "AD") {
                                                        $scope.administrators.push({
                                                            codigo: $scope.allUsers[i].idOperador,
                                                            nombre: $scope.allNamesAsoc[$scope.allUsers[i].idOperador],
                                                            username: $scope.allUsernamesAsoc[$scope.allUsers[i].idOperador]
                                                        });
                                                    } else if ($scope.allUsers[i].profile == "AG") {
                                                        $scope.administratorsG.push({
                                                            codigo: $scope.allUsers[i].idOperador,
                                                            nombre: $scope.allNamesAsoc[$scope.allUsers[i].idOperador],
                                                            username: $scope.allUsernamesAsoc[$scope.allUsers[i].idOperador]
                                                        });
                                                    }
                                                }
                                                localStorage.setItem("arrayOperators", JSON.stringify($scope.operators));
                                                localStorage.setItem("arrayAdministrators", JSON.stringify($scope.administrators));
                                                localStorage.setItem("arrayAdministratorsG", JSON.stringify($scope.administratorsG));
                                                //Obtenemos los días de operacion cerradas
                                                var estadoOp = [];
                                                var requestData = {};
                                                requestData = (function mapping7565($scope) {
                                                    var requestData = {};
                                                    requestData.params = {};
                                                    requestData.params.where = {
                                                        "idEmpresa": $scope.company[0].idCliente
                                                    };
                                                    requestData.params.sort = "-fechaOperacion";
                                                    requestData.params.limit = 365;
                                                    return requestData;
                                                    /*CLICK TO EDIT MAPPING*/
                                                })($scope);
                                                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                                                Apperyio.get("Tech1_OPERATIONDAY_query_service")(requestData).then(
                                                    function(success) { // success callback
                                                        (function mapping8011(success, $scope) {
                                                            var estadoOp_scope = estadoOp;
                                                            for (var i = 0, l = success.data.length; i < l; i++) {
                                                                _.set(estadoOp_scope, '[' + i + '].estado', success.data[i].estadoOperacion);
                                                                _.set(estadoOp_scope, '[' + i + '].fecha', formDate4(success.data[i].fechaOperacion));
                                                            }
                                                            estadoOp = estadoOp_scope;
                                                            /*CLICK TO EDIT MAPPING*/
                                                        })(success, $scope);
                                                        localStorage.setItem("diasOperacion", JSON.stringify(estadoOp));
                                                        $scope.stopLoading();
                                                        //Saltamos a la página de inicio
                                                        Apperyio.navigateTo("Inicio", {});
                                                    },
                                                    function(error) { // callback to handle request error
                                                        $scope.mAlert("Hubo errores al cargar los días de operación: " + error.data.code + " " + error.data.description);
                                                        $scope.stopLoading();
                                                        localStorage.clear();
                                                    },
                                                    function(notify) { // notify callback, can fire few times
                                                    });
                                            },
                                            function(error) { // callback to handle request error
                                                $scope.stopLoading();
                                                alert("Errores al recuperar el listado de usuarios operadores: " + error.data.code + " " + error.data.description);
                                                localStorage.clear();
                                            },
                                            function(notify) { // notify callback, can fire few times
                                            });
                                    },
                                    function(error) { // callback to handle request error
                                        $scope.stopLoading();
                                        alert("Errores al recuperar el listado de operadores");
                                        localStorage.clear();
                                    },
                                    function(notify) { // notify callback, can fire few times
                                    });
                            }
                            /*|button_mapping|onsuccess|7A3ADDB1-07B8-4ECB-610D-20DCB0DCEAB4||3472|*/
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        alert("No se puede recuperar datos de empresa " + companyId + ": " + error.data.code + " " + error.data.description);
                        localStorage.clear();
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function formDate4
             * @param fecha
             */
            function formDate4(fecha) {
                if (!fecha)
                    return fecha;
                var arrFecha = fecha.split(" ");
                return arrFecha[0];
            };
            /**
             * @function gotoRc
             */
            $scope.gotoRc = function() {
                Apperyio.navigateTo("pr", {});
            };
        }
    });